VERSION 5.00
Begin VB.Form printMan_MainWin 
   Caption         =   "PrintMan V1.3"
   ClientHeight    =   1305
   ClientLeft      =   7740
   ClientTop       =   6660
   ClientWidth     =   3210
   Icon            =   "printMan_MainWin.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1305
   ScaleWidth      =   3210
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'Kein
      FillColor       =   &H00FFFFFF&
      ForeColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   120
      Picture         =   "printMan_MainWin.frx":09CA
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   2
      Top             =   120
      Width           =   495
   End
   Begin VB.CommandButton Ok 
      Caption         =   "Ok"
      Height          =   375
      Left            =   2040
      TabIndex        =   1
      Top             =   840
      Width           =   1095
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   3120
      Y1              =   720
      Y2              =   720
   End
   Begin VB.Label Info 
      Height          =   495
      Left            =   735
      TabIndex        =   0
      Top             =   150
      Width           =   2300
   End
End
Attribute VB_Name = "printMan_MainWin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' module: printMan - mainwin
' McT / 17.12.02
' checked ~ V1.3

Option Explicit

' *********************************************
' vars
' *********************************************

' -> sw objects
Private sw As Object, drw As Object, sheet As Object, pSetup As Object

' -> cfg array
Private prtNames(4) As String, prtSizes(4) As Long

' -> misc
Private errTxt$, demoMode As Boolean

' *********************************************
' main
' *********************************************

Private Sub Form_Load()
' *************
' -> main
' *************

    demoMode = False

    bootUp
    getPlotters
    printDrawing
    shutDown
    
    End
    
End Sub

' *********************************************
' private
' *********************************************

Private Sub getPlotters()
' *************
' -> get plotter names
' *************

    ' -> error check
    If errTxt <> "" Then Exit Sub

    ' -> vars
    Dim sBuf1$, sBuf2$, i&, j&
    
    ' -> error handling
    On Error GoTo wrongConfig
    
    ' -> open cfg file ##+
   Open App.Path & "\printman.cfg" For Input As #1

   
   ' Open App.Path & "\printman.txt" For Input As #1

        ' -> jump to line 3
        Line Input #1, sBuf1
        Line Input #1, sBuf1
        Line Input #1, sBuf1
        
        ' -> read printers
        For i = 0 To 4
            ' -> read name
            Input #1, sBuf1, sBuf2, sBuf1
            prtNames(i) = ""
            ' -> verify name
            For j = 0 To Printers.Count - 1
                If UCase(Printers(j).DeviceName) = UCase(sBuf1) Then
                    prtNames(i) = Printers(j).DeviceName
                    Exit For
                End If
            Next j
            ' -> size
            prtSizes(i) = Val(sBuf2)
        Next i
    
    Close #1

    Exit Sub

wrongConfig:

    errTxt = "Drucker Konfiguration fehlerhaft !"
    checkErr

End Sub

Private Sub printDrawing()
' *************
' -> print drawing
' *************
  
   ' -> error check
    If errTxt <> "" Then Exit Sub
  
    ' -> vars
    Dim drucker$, fmt&, field, size&, sNr&
    
    ' -> get paper size
    field = sheet.getproperties
    
    ' -> select printer, and print properties
    Select Case field(0)
        Case swDwgPaperA4sizeVertical
            drucker = prtNames(0): fmt = vbPRORPortrait: size = prtSizes(0)
        Case swDwgPaperA3size
            drucker = prtNames(1): fmt = vbPRORLandscape: size = prtSizes(1)
        Case swDwgPaperA2size
            drucker = prtNames(2): fmt = vbPRORLandscape: size = prtSizes(2)
        Case swDwgPaperA1size
            drucker = prtNames(3): fmt = vbPRORLandscape: size = prtSizes(3)
        Case swDwgPaperA0size
            drucker = prtNames(4): fmt = vbPRORLandscape: size = prtSizes(4)
        Case Else
            ' -> set to demo mode
            demoMode = True
    End Select

    If drucker <> "" Then
    
        ' -> select printer
        drw.Printer = drucker
        
        ' -> color: black & white
        sw.SetUserPreferenceIntegerValue swPageSetupPrinterDrawingColor, swPageSetup_BlackAndWhite
       
        ' -> orientation
        pSetup.Orientation = fmt
        
        ' -> size
        pSetup.PrinterPaperSize = size
        
        ' -> scale mode
        pSetup.ScaleToFit = False
        pSetup.Scale2 = 100
    
        ' -> get sheet number
        sNr = Val(Right(drw.GetCurrentSheet.getname, 1))
        
        If Not demoMode Then
            ' -> print
            drw.PrintOut2 sNr, sNr, 1, False, "", 1#, False, ""
        Else
            ' -> simluation
            drw.PrintPreview
        End If
    Else

        errTxt = "Drucker - Konfiguration fehlerhaft !"
        checkErr

    End If
    
End Sub


' *********************************************
' init / free
' *********************************************

Private Sub bootUp()
' *************
' -> get sw access
' *************
    
    errTxt = ""
    On Error Resume Next

    ' -> try to access sw
    Set sw = GetObject(, "sldworks.application")
    If Not sw Is Nothing Then
    
        ' -> check for open document
        Set drw = sw.activedoc
        If Not drw Is Nothing Then
            
            
            If drw.GetType = swDocDRAWING Then
            
                Set sheet = drw.GetCurrentSheet
                ' -> page setup
                Set pSetup = drw.pagesetup
                
            Else
                errTxt = "Es werden nur SolidWorks - Zeichnungen untersttzt !"
            End If
        Else
            errTxt = "Kein SolidWorks - Dokument geladen !"
        End If
        
    Else
        errTxt = "Keine aktive SolidWorks - Instanz gefunden !"
    End If

    checkErr

End Sub



Private Sub shutDown()
' *************
' -> cleanup
' *************
    
    Set pSetup = Nothing
    Set sheet = Nothing
    Set drw = Nothing
    Set sw = Nothing

End Sub

' *********************************************
' misc
' *********************************************

Public Sub checkErr()
' *************
' -> show error
' *************

    If errTxt <> "" Then
        Info.Caption = errTxt
        Show vbModal
    End If

End Sub

Private Sub Ok_Click()
    Hide
End Sub


